leetcode-两数之和
给定一个整数数组 nums
和一个目标值 target
,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
第一反应是直接暴力搜索:
public int[] twoSum(int[] nums, int target) {
int[] result = new int[2];
for (int i = 0; i < nums.length; i++) {
for (int j = i+1; j < nums.length; j++) {
if(nums[i] + nums[j] == target) {
result[0] = i;
result[1] = j;
}
}
}
return result;
}
之后想了想,看了看评论,发现使用HashMap来做的话会将时间复杂度降到O(n)。
public int[] twoSum_best(int[] nums, int target) {
Map<Integer,Integer> map = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; i++) {
int complement = target - nums[i];
if(map.containsKey(complement) && i != map.get(complement)) {
return new int[] {i,map.get(complement)};
}
map.put(nums[i], i);
}
throw new IllegalArgumentException(" no two sum solution");
}
提交结果
暴力搜索
使用HashMap